/*******************************************************************************

   Frame with box collision detection
     
   Date: (2005): initial version
   
   Authors: Clay Smith
   
   Liscense: See <a href="http://www.opensource.org/licenses/zlib-license.php">zlib/libpng license</a>

Examples:
-------------------------------------------------------------------------------
import arc.gfx.frame.boxframe,
       arc.io.input;

int main() {
   
   // new boxframe with image and zoom amount
   Frame boxframe = new BoxFrame("img.png", 3.0); 

   return 0;
}
-------------------------------------------------------------------------------
*******************************************************************************/
module arc.gfx.frame.boxframe; 

public import arc.gfx.frame.frame;

private import std.math; 

private import arc.gfx.gfxutil, 
               arc.gfx.texture,
			   arc.io.sound,
               arc.io.window,
               arc.phy.point;
			   

private import derelict.opengl.gl,
               derelict.sdl.sdl,
               derelict.sdl.image;


/// Frame with box based collision detection
class BoxFrame : Frame
{
  public:

	this() {}

   
	this(char[] argFullFileName, int argTime, Sound argSnd, inout Point s)
	{
		s = init(argFullFileName, argTime, argSnd);
	}

	this(Texture tex, int argTime, Sound argSnd, inout Point s)
	{
		s = init(tex, argTime, argSnd);
	}

	Point init(char[] argFullFileName, int argTime, Sound argSnd)
	{
		// will crash if file doesn't exist
		assert (std.file.exists(argFullFileName));	

		// turn image into an OpenGL texture
		Texture tex = arc.gfx.texture.texture(argFullFileName);

		ID = tex.getID;

		time = argTime;
		snd = argSnd;

		Point s = Point(tex.getWidth, tex.getHeight);
		return s;
	}

	Point init(Texture tex, int argTime, Sound argSnd)
	{
		ID = tex.getID;

		time = argTime;
		snd = argSnd;

		Point s = Point(tex.getWidth, tex.getHeight);
		return s;
	}

	int getID() { return ID; }

   ~this()  
   {
   }

  private:
   int ID;
}
