/*******************************************************************************

   Holds a single frame
     
   Date: (2005): initial version
   
   Authors: Clay Smith
   
   Liscense: See <a href="http://www.opensource.org/licenses/zlib-license.php">zlib/libpng license</a>

Examples:
-------------------------------------------------------------------------------
import arc.gfx.frame.frame;

int main() {
   
   Frame f = new BoxFrame/RadFrame/PixFrame();

   return 0;
}
-------------------------------------------------------------------------------
*******************************************************************************/
module arc.gfx.frame.frame;

import 	arc.phy.point,
		arc.io.sound;
				
import arc.io.log; 

/// Holds either PIXEL, RADIUS, or BOX.
enum COLLISION_TYPE
{
	RADIUS=0,
	CIRCLE = RADIUS,
	BOX
}

/// common base to PixFrame, BoxFrame, and RadFrame
class Frame 
{
  public:
	// default const/dest
	this(){}
	~this(){}

	/// draw frame (box)
	void draw(	float argX, float argY, float argW, float argH,
				short argR, short argG, short argB, short argA,
				float pivX, float pivY)
	{
		debug writefln("frame: Please use RadFrame, BoxFrame, or PixFrame instead");
		assert(0);	
	}

	/// draw bounds for box function
	void drawBounds(float nx, float ny, float width, float height,
					short r, short b, short g, short a)
	{
		debug writefln("frame: Please use RadFrame, BoxFrame, or PixFrame instead");
		assert(0);
	}

	/// test collision against a box frame
	bool boxCol(Frame boxframe, float x1, float y1, 
				float x2, float y2, float w2, float h2,
				float argAngle, float argGap)
	{
		debug writefln("Frame type doesn't support box collision");
		assert(0);
		return false;  
	}

	/// returns true if collides against a BoxFrame
	bool boxCol(float nx1, float ny1, float w1, float h1, 
				float nx2, float ny2, float w2, float h2)
	{	
		debug writefln("Frame type doesn't support box collision");
		assert(0);
		return false;
	}

   /// test collision against a radius frame
	bool radCol( float x1, float y1, float w1, float h1,
				float x2, float y2, 
				float argAngle, float argGap, float radius)
   {
      debug writefln("Only supported by RadFrame");
      assert(0);
      return false; 
   }

   void reload(double zx, double zy, float gap)
   {
	   assert(0);
   }

   float getCX() { assert(0); return 0; }
   float getCY() { assert(0); return 0; }

	int getID() { assert(0); }

	void process() {}

	bool xyCol(float argX, float argY, float x, float y, float angle, float gap)
	{
		assert(0);
		return false;
	}

	// time it will be displayed for
	int time=30;
	// and sound effect
	Sound snd;
}

