module arc.gui.gui; 

alias void delegate() callBackFunc; 



class GUI
{
  public:
 
    this()
    {
        
    }

    void callCode(char[] layout, char[] widget)
    {
        callBackList[layout][widget].call();
    }
    
    void process()
    {
        // call user code 
        foreach(char[] layout; callBackList.keys)
        {
            foreach(CallBacks code; callBackList[layout])
            {
                code.call();      
            }
        }
    }
    
    void setCallBack(char[] layout, char[] widget, CallBacks cbs)
    {
        callBackList[layout][widget] = cbs;
    }
    
    CallBacks[char[]][char[]] callBackList;
}

struct CallBacks
{
  public:
    callBackFunc[] cbs;
  
    void call()
    {
        foreach(callBackFunc c; cbs)
            c();
    }
    
    void addCallBack(callBackFunc cb)
    {
        cbs.length = cbs.length + 1;
        int curr = cbs.length-1;
        
        cbs[curr] = cb;
    }
}