/*******************************************************************************

Description: Utilities for input/output

Authors: Clay Smith

Liscense: See <a href="http://www.opensource.org/licenses/zlib-license.php">zlib/libpng license</a>

Examples:
--------------------
import std.string;
import arc.io.ioutil; 

int main() {

   // format vararg text
   void mywritef(...)
   {
      dchar[] text = arc.io.ioutil.formatstring(_arguments, _argptr); 
      printf("%s\n", std.string.toString(text));
   }

   return 0;
}
--------------------

*******************************************************************************/

module arc.io.ioutil;

private import std.stdio, 
               std.format; 


/// format vardic arguments and returns it as a string
dchar[] formatString(TypeInfo[] arguments, void *argptr) 
{
   dchar[] message = null; 
   
   void putc(dchar c)
   {
      message ~= c; 
   }
   
   std.format.doFormat(&putc, arguments, argptr);
   
   return message; 
} 

