module arc.io.xml.misc;

private import std.string;


bit isLetter(char c)
{   return find(letters, c) != -1;
}

bit isNumber(char c)
{   return find(digits, c) != -1;
}

bit isWhiteSpace(char c)
{   return find(whitespace, c) != -1;
}

bit isAlphaNumeric(char c)
{   return isLetter(c) || isNumber(c);
}

bit isTokenChar(char c)
{   static const char[] tokenChars = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ-_";
    return find(tokenChars, c) != -1;
}

char[] encodeSpecialChars(char[] src)
{
    // Convert sensitive characters to code thingies so that the XML isn't butchered by the cdata.
    // This probably isn't the most efficient way to do this.
    char[] tempStr;
    tempStr = replace(src    , "&", "&amp;");
    tempStr = replace(tempStr, "<", "&lt;");
    tempStr = replace(tempStr, ">", "&gt;");
    return tempStr;
}

char[] decodeSpecialChars(char[] src)
{
    // undoes what encodeSpecialChars does
    char[] tempStr;
    tempStr = replace(src    , "&amp;", "&");
    tempStr = replace(tempStr, "&lt;",  "<");
    tempStr = replace(tempStr, "&gt;",  ">");

    return tempStr;
}
