﻿module classes.gui;

private import init.init;

class FU_BUTTON {
private:
	int x, y, w, h;
	char[] text;
	short r, g, b;
	Font font;
	void calcSize() {
		font.draw(text, 0, 0, 0, 0, 0, 0);
		w = text.length * 12 + 20;
		h = cast(int)font.getHeight() + 15;		
	}
public:
	this(char[] buttonText) {
		text = buttonText;
		font = bigFont;
		calcSize();
		r = 255; g = 255; b = 255;
	}
	void setPosition(int parmX, int parmY) {
		x = parmX;
		y = parmY;
	}
	void setText(char[] newText) {
		text = newText;
		calcSize();
	}
	int getHeight() { return h; }
	int getWidth() { return w; }
	void chopWidth(int chopSize) {
		w -= chopSize;
		if( w < 0 ) w = 0;
	}
	void setColor(short R, short G, short B) { r = R; g = G; b = B; }
	bool isClicked() {
		if( mouseHit(LEFT) == true ) {
			if( mouseX >= x && mouseX <= x + w && mouseY >= y && mouseY <= y + h ) {
				playSingleSound(SOUND_CLASS.SELECT);
				return true;
			}
		}
		return false;
	}
	void draw(bool useGreen = false) {
		if( w == 0 ) return;
		drawRect(x+1, y+1, w-2, h-2, 0, 0, 0, 150, true);
		if( useGreen == true ) {
			drawRect(x, y, w, h, 0, 255, 0, 255, false);
			font.draw(text, x+12, y+7, 0, 255, 0, 255);
		} else {
			drawRect(x, y, w, h, r, g, b, 255, false);
			font.draw(text, x+12, y+7, r, g, b, 255);
		}
	}
};
