﻿module classes.particle;

private import classes.fu_object;
private import init.init;
private import arc.io.freelist;

class FU_PARTICLE : FreeList!(FU_PARTICLE) {
private:
	float currentSize, currentSizeRate;
	double x = 0, y = 0, x_speed = 0, y_speed = 0;
	short r, g, b, a;
	bool extended;
	short a_drop_rate = 1;
public:
	this() {}
	~this() {}
	void construct(FU_OBJECT source, short parmR, short parmG, short parmB, float startingSize = 0, bool parmExtended = false) {
		x = source.getX();
		y = source.getY();
		x_speed = 0;
		y_speed = 0;
		a = 255;
		r = parmR;
		g = parmG;
		b = parmB;
		extended = parmExtended;
		if( startingSize == 0 ) {
			currentSize = source.getSprite().getWidth();
			if( source.getSprite().getHeight() > currentSize ) currentSize = source.getSprite().getHeight();
			currentSize *= 0.25;
		} else currentSize = startingSize;
		if( extended == false ) {
			a_drop_rate = 255 / cast(short)currentSize;
			currentSizeRate = -currentSize / (a / a_drop_rate);
		} else {
			a_drop_rate = 5;
			currentSizeRate = 0;
		}
		GameObjects.addParticle(this);
	}
	void setSpeed(float xSpeed, float ySpeed) {
		x_speed = xSpeed;
		y_speed = ySpeed;
	}
	// returns true if particle still exists
	bool draw() {
		x += x_speed;
		y += y_speed;
		drawCircle(x, y, currentSize, 30, r, g, b, a, true);
		if( rand()%3<2 ) {
			a -= a_drop_rate;
			currentSize += currentSizeRate;
		}
		if( a <= 0 || currentSize <= 0 ) return false;
		return true;
	}
};

	
