﻿module menu.main_menu;

private import init.init;
private import arc.gfx.sprite;
private import classes.gui;

Sprite menu_bg_image;

FU_BUTTON loadGame, newGame, exitGame, resumeGame;

void initMainMenu() {
	menu_bg_image = new Sprite("gfx/title_screen.png",COLLISION_TYPE.RADIUS);
	loadGame = new FU_BUTTON("Load Game");
	newGame = new FU_BUTTON("New Game");
	exitGame = new FU_BUTTON("Exit Game");
	resumeGame = new FU_BUTTON("Resume Game");
	exitGame.chopWidth(5);
	newGame.setPosition(400 - newGame.getWidth() / 2, 250);
	loadGame.setPosition(400 - loadGame.getWidth() / 2, 300);
	exitGame.setPosition(400 - exitGame.getWidth() / 2, 350);
	resumeGame.setPosition(400 - resumeGame.getWidth() / 2, 200);
}

void drawBackground() {
	menu_bg_image.setX(SCREEN_X/2);
	menu_bg_image.setY(SCREEN_Y/2);
	menu_bg_image.setPivot(0,0);
	menu_bg_image.setColor(255,255,255,255);
	menu_bg_image.draw();
	standardFont.draw("Press [ESC] to return or quit.",0,585,255,255,255,255);
}

bool keyHeld = false;
char[] loadGameName;
void DisplayLoadGame() {
	drawBackground();
	drawDarkBox(100, 200, 600, 300);
	bigFont.draw("Type profile name: " ~ loadGameName ~ " < Press Enter >", 110, 210, 255, 255, 255, 255);
	char[][] existingProfiles = listdir("saves/","*.ship");
	bigFont.draw("Existing Profiles:", 300, 230, 255, 255, 255, 255);
	int drawY = 250;
	foreach(char[] profile; existingProfiles) {
		profile.length = profile.length - 5;
		standardFont.draw(profile[7..profile.length], 110, drawY, 255, 255, 255, 255);
		drawY += 12;
	}
	if(arc.io.input.charHit) {
		foreach(ch; arc.io.input.lastChars) {
			if( loadGameName.length < 12 && (ch >= 'a' && ch <= 'z' || ch >= 'A' && ch <= 'Z') ) loadGameName ~= ch;
			else if( ch == SDLK_BACKSPACE && loadGameName.length > 0 ) loadGameName.length = loadGameName.length - 1;
		}
	}
	if( arc.io.input.keyHit(SDLK_ESCAPE) == true ) gameState = GAME_STATE.MAIN_MENU;
	else if( arc.io.input.keyHit(SDLK_RETURN) == true ) {
		char[] fileName = "saves/" ~ loadGameName ~ ".ship";
		if( exists(fileName) == true ) {
			quitCurrentGame();
			gameState = GAME_STATE.SPACE;
			initPlayer(fileName);
			playerName = loadGameName;
		}
	}
}

char[] story = 
"Years have passed since the planet of Esperanza has thrived,\n
and you have set off into space to find new adventures.\n
Your good wealth allowed you to purchase a small shuttle\n
complete with all the necessities of space travel.";

void DisplayNewGame() {
	drawBackground();
	if( arc.io.input.keyHit(SDLK_ESCAPE) == true ) gameState = GAME_STATE.MAIN_MENU;
	drawDarkBox(100, 200, 600, 300);
	bigFont.draw("Welcome to the FreeUniverse",290,202,255,255,255,255);
	bigFont.draw(story, 110, 230, 255, 255, 255, 255);
	bigFont.draw("Type profile name: " ~ loadGameName ~ " < Press Enter >", 110, 475, 255, 255, 255, 255);
	if(arc.io.input.charHit) {
		foreach(ch; arc.io.input.lastChars)
		{
			if( loadGameName.length < 12 && (ch >= 'a' && ch <= 'z' || ch >= 'A' && ch <= 'Z') ) loadGameName ~= ch;
			else if( ch == SDLK_BACKSPACE && loadGameName.length > 0 ) loadGameName.length = loadGameName.length - 1;
		}
	}
	if( arc.io.input.keyHit(SDLK_RETURN) && loadGameName.length > 0 ) {
		quitCurrentGame();
		gameState = GAME_STATE.SPACE;
		initPlayer("");
		playerName = loadGameName;
	}
}

void DisplayMainMenu() {
	drawBackground();
	loadGame.draw();
	newGame.draw();
	exitGame.draw();
	if( PlayerShip !is null ) resumeGame.draw();
	if( arc.io.input.keyHit(SDLK_ESCAPE) || exitGame.isClicked() == true ) {
		gameState = GAME_STATE.QUIT;
		return;
	}
	if( loadGame.isClicked() == true ) {
		loadGameName = "";
		gameState = GAME_STATE.LOAD_GAME;
	}
	if( newGame.isClicked() == true ) {
		gameState = GAME_STATE.NEW_GAME;
		loadGameName = "Anonymous";
	}
	if( resumeGame.isClicked() == true && PlayerShip !is null ) gameState = GAME_STATE.SPACE;
}
