﻿module space.hud;

private import init.init;
private import classes.fu_object;
private import classes.ship;
private import classes.item;
private import std.math;
private import derelict.sdl.sdl; 
import arc.phy.point;

char[][3] HUDmessages;
short[3] HUDmessages_r, HUDmessages_g, HUDmessages_b, HUDmessages_a;
void addMessage(char[] message, short red, short green, short blue) {
	foreach(int i, char[] HUDM; HUDmessages) {
		if( HUDM == message ) {
			HUDmessages_a[i] = 255;
			HUDmessages_r[i] = red;
			HUDmessages_g[i] = green;
			HUDmessages_b[i] = blue;
			return;
		}
	}
	short lowestAlpha = 256, useIndex = -1;
	for(int i=0; i<3; i++) {
		if( HUDmessages_a[i] < lowestAlpha ) {
			lowestAlpha = HUDmessages_a[i];
			useIndex = i;
		}
	}
	HUDmessages[useIndex] = message;
	HUDmessages_r[useIndex] = red;
	HUDmessages_g[useIndex] = green;
	HUDmessages_b[useIndex] = blue;
	HUDmessages_a[useIndex] = 255;
}

bool showingItems = false, showingTarget = false, showingCircle = false, showingJob = false, showingEffects = false;
FU_ITEM detailItemShowing = null;
void drawSpaceHUD(FU_ITEM playerSensor) {
	debug scope(failure) { writefln("drawSpaceHUD: hud.d"); }	
	
	if( PlayerShip.getArmor() <= 0 ) {
		largeFont.draw("Destroyed Ship",275,200,255,20,20,255);
		bigFont.draw("Hit [ESCAPE] to return to the main menu.",235,320,255,20,20,255); 
		return;
	}
	// display text
	standardFont.draw("Shields:\nArmor:\nEnergy:",194,574,255,255,255,100);
	// draw energy, shield and armor bars
	float current, max;
	// shields
	PlayerShip.modifyUtilityCounter(ITEM_CLASS.SHIELDS, 0, &current, &max);
	drawRect( 250, 574, 300 * (current / max), 8, 0, 30, 255, 150, true);
	// armor
	drawRect( 250, 583, 300 * PlayerShip.percentArmorRemaining(), 8, 200, 20, 200, 150, true);
	// energy
	PlayerShip.modifyUtilityCounter(ITEM_CLASS.GENERATOR, 0, &current, &max);
	drawRect( 250, 592, 300 * (current / max), 8, 255, 255, 0, 150, true);

	// draw sensor/radar
	if( playerSensor !is null ) {
		standardFont.draw("SecX: " ~ std.string.toString(MainGenerator.getCellX()) ~ "\nSecY: " ~ std.string.toString(MainGenerator.getCellY()), 730, 419, 255, 255, 255, 100);
		drawCircle(720,520,79,30,255,255,255,200,false);
		drawLine(720-79,520,720+79,520,255,255,255,8);
		drawLine(720,520-79,720,520+79,255,255,255,8);
	}

	// draw target indicator
	showingCircle = false;
	if( objectExists(PlayerShip.getTarget()) == true ) {
		/*
			draw target rect
		*/
		// get position of target in interface coordinate system
		Point target_screen_pos = interface_view.normalized_to_camera(space_view.camera_to_normalized(Point(PlayerShip.getTarget().getSprite().getX(), PlayerShip.getTarget().getSprite().getY())));
		
		// get larger width of the target, scaled by zoom
		float ww = PlayerShip.getTarget().getSprite().getWidth()/2 / space_view.getZoom();
		if( PlayerShip.getTarget().getSprite().getHeight()/2 > ww ) ww = PlayerShip.getTarget().getSprite().getHeight()/2 / space_view.getZoom();
		
		// determine colour of target box
		short boxR = 20, boxG = 255, boxB = 20;
		if( PlayerShip.getTarget().getType() == OBJECT_TYPE.ITEM ) { boxR = 255; boxG = 255; boxB = 255; }
		else if( abs( PlayerShip.getTarget().getFaction() - PlayerShip.getFaction() ) > 1 ) { boxR = 255; boxG = 255; boxB = 20; }
		if( PlayerShip.getTarget().getType() == OBJECT_TYPE.SHIP &&
			PlayerShip.getTarget() !is PlayerShip &&
			(cast(FU_SHIP)PlayerShip.getTarget()).getAIAction() == AI_ACTION.ATTACKING &&
			(cast(FU_SHIP)PlayerShip.getTarget()).getTarget() is PlayerShip ) { boxR = 255; boxG = 20; boxB = 20; }
		
		// draw it
		drawRect(target_screen_pos.getX() - ww, target_screen_pos.getY() - ww,
			ww*2, ww*2, boxR, boxG, boxB, cast(short)((sin(globalTimer>>2) + 1)/2 * 255), false);
		
		
		// draw status bars
		drawRect( 575, 490, 43, 210, 255, 255, 255, 25, true);
		standardFont.draw("Target",575,591,255,255,255,255);
		if( PlayerShip.getTarget().getType() == OBJECT_TYPE.SHIP ) {
			(cast(FU_SHIP)PlayerShip.getTarget()).modifyUtilityCounter(ITEM_CLASS.SHIELDS, 0, &current, &max);
			drawRect( 578, 590, 16, -100 * (current / max), 75, 150, 255, 150, true);
		}
		drawRect( 598, 590, 16, -100 * PlayerShip.getTarget().percentArmorRemaining(), 250, 70, 250, 150, true);
		
		// draw direction HUD
		if( PlayerShip.getTarget().getSprite().onScreen() == false ) {
			Point normalized_pos = space_view.camera_to_normalized(Point(PlayerShip.getTarget().getSprite().getX(), PlayerShip.getTarget().getSprite().getY()));
			if( normalized_pos.getX() < 0 || normalized_pos.getY() < 0 || normalized_pos.getX() > 1 || normalized_pos.getY() > 1) {
				showingCircle = true;
				drawCircle( SCREEN_X/2, SCREEN_Y/2, 200, 25, 255, 255, 255, 70, false);
				float angDir = pointAtAngle(PlayerShip.getX(), PlayerShip.getY(), PlayerShip.getTarget().getX(), PlayerShip.getTarget().getY());
				drawCircle( SCREEN_X/2 + moveToValueX(angDir) * 200, SCREEN_Y/2 + moveToValueY(angDir) * 200, 5, 10, boxR, boxG, boxB, 150, true);
			}
		}
		
		// right click to disable
		if( arc.io.input.mouseHit(RIGHT) == true ) PlayerShip.setTarget(null);
	}
	// draw waypoint arrow
	if( PlayerShip.WaypointIndex() != -1 ) {
		double wpDist = distance(PlayerShip.getX(), PlayerShip.getY(), PlayerShip.getWaypointX(), PlayerShip.getWaypointY());
		if( wpDist > 300 ) {
			if( showingCircle == false ) drawCircle( SCREEN_X/2, SCREEN_Y/2, 200, 25, 255, 255, 255, 70, false);
			float angDir = pointAtAngle(PlayerShip.getX(), PlayerShip.getY(), PlayerShip.getWaypointX(), PlayerShip.getWaypointY());
			drawCircle( SCREEN_X/2 + moveToValueX(angDir) * 200, SCREEN_Y/2 + moveToValueY(angDir) * 200, 5, 10, 255, 20, 255, 150, false);
		}
		if( wpDist < 425 ) {
			drawCircle( PlayerShip.getWaypointX(), PlayerShip.getWaypointY(), 6, 10, 255, 20, 255, 150, false);
			drawCircle( PlayerShip.getWaypointX(), PlayerShip.getWaypointY(), 10, 10, 255, 20, 255, 150, false);
		}
	}
	if( showingItems == true ) {
		int drawY = 1, drawX = 0;
		PlayerShip.items.reset();
		while(!PlayerShip.items.last()) {
			PlayerShip.items.data.drawDisplay(drawX,drawY,ITEMDISPLAY_MODE.COMPACT);
			if( PlayerShip.items.data.displayClicked() == true ) {
				if( arc.io.input.keyDown('i') == true ) detailItemShowing = PlayerShip.items.data;
				else if( arc.io.input.keyDown('j') == false ) PlayerShip.items.data.setEnable(!PlayerShip.items.data.getEnable);
				else {
					PlayerShip.jettison(PlayerShip.items.data);
					break;
				}
			}
			drawY += DISPLAY_HEIGHT[ITEMDISPLAY_MODE.COMPACT];
			if( drawY > 600 - DISPLAY_HEIGHT[ITEMDISPLAY_MODE.COMPACT] ) {
				drawY = 0;
				drawX += DISPLAY_WIDTH[ITEMDISPLAY_MODE.COMPACT];
			}
			if( PlayerShip.items.data is detailItemShowing )
				PlayerShip.items.data.drawDisplay(100,100,ITEMDISPLAY_MODE.DETAILED);
		}
		if( arc.io.input.mouseX > DISPLAY_WIDTH[ITEMDISPLAY_MODE.COMPACT]*2 ) {
			showingItems = false;
			detailItemShowing = null;
		}
	} else if( arc.io.input.mouseX == 0 ) showingItems = true;

	if( showingTarget == true ) {
		drawDarkBox(400 - 100, 1, 200, 52);
		if( objectExists(PlayerShip.getTarget()) == false ) standardFont.draw("No target selected.", 400 - 98, 2, 255, 255, 255, 255);
		else {
			standardFont.draw("Level: " ~ std.string.toString(PlayerShip.getTarget().getLevel()), 400 - 98, 12, 255, 255, 255, 255);
			standardFont.draw("Faction: " ~ FactionNames[PlayerShip.getTarget().getFaction()], 400 - 98, 22, 255, 255, 255, 255);
			if( PlayerShip.getTarget().getType() == OBJECT_TYPE.SHIP ) {
				FU_SHIP tShip = cast(FU_SHIP)PlayerShip.getTarget();
				if(tShip !is PlayerShip ) {
					standardFont.draw("Occupation: " ~ AIClassNames[tShip.getAIClass()], 400 - 98, 32, 255, 255, 255, 255);
					standardFont.draw("Action: " ~ AIActionNames[tShip.getAIAction()], 400 - 98, 42, 255, 255, 255, 255);
				} else {
					standardFont.draw("Credits: " ~ std.string.toString(playerCredits), 400 - 98, 32, 255, 255, 255, 255);
				}
				standardFont.draw("Ship: " ~ ShipTypeNames[(cast(FU_SHIP)PlayerShip.getTarget()).getShipType()], 400 - 98, 2, 255, 255, 255, 255);
			} else standardFont.draw("Object: " ~ ObjectNames[PlayerShip.getTarget().getType()], 400 - 98, 2, 255, 255, 255, 255); 
			if( PlayerShip.getTarget().getType() == OBJECT_TYPE.ITEM ) {
				FU_ITEM tItem = PlayerShip.getTarget().getItem();
				standardFont.draw("Item Type: " ~ ItemNames[tItem.getClass()], 400 - 98, 32, 255, 255, 255, 255);
				if( tItem.getType() == ITEM_TYPE.CARGO ) {
					standardFont.draw("Cargo Type: " ~ CargoNames[tItem.getCargoType()], 400 - 98, 42, 255, 255, 255, 255);
				}
			}
		}
		if( arc.io.input.mouseY > 50 ) showingTarget = false;
	} else if( arc.io.input.mouseY == 0 ) showingTarget = true;

	if( showingJob == true && PlayerShip.getCurrentJob() !is null && detailItemShowing is null ) {
		PlayerShip.getCurrentJob().drawDisplay(100, 100, ITEMDISPLAY_MODE.DETAILED);
		bigFont.draw("Press 'F8' to cancel job.",290,405,255,255,255,255);
		if( arc.io.input.keyHit('o') == true ) showingJob = false;
		else if( arc.io.input.keyHit(SDLK_F8) == true ) PlayerShip.cancelJob();
	} else if( arc.io.input.keyHit('o') == true ) {
		if( PlayerShip.getCurrentJob() !is null ) showingJob = true;
		else space.hud.addMessage("No current job.",255,255,20);
	} else showingJob = false;

	/* DISABLE_SHIELD_CHARGE = 0, // OK
	DISABLE_ENGINES, // OK
	DISABLE_WEAPONS, // OK
	DISABLE_CLOAK, // OK
	DISABLE_RADAR, // OK
	DISABLE_ENERGY_CHARGE, // OK

	// good things
	REPAIR_HULL = MODIFIER_SEPERATOR, // OK
	REPAIR_ITEMS, // OK
	INCREASE_SPEED, // OK
	INCREASE_DAMAGE, // OK
	INCREASE_SHIELDS_CHARGE, // OK
	INCREASE_ENERGY_CHARGE, // OK */
	
	// draw modifier effects
	if( showingJob == false && detailItemShowing is null && showingEffects == true ) {
		bool anyEffects = false;
		int y_draw = 150;
		drawDarkBox(200, 140, 400, (BAD_MODIFIER_COUNT+GOOD_MODIFIER_COUNT+2) * 20);
		for(int i=0;i<MODIFIER_TYPE.max+1;i++) {
			if( PlayerShip.getModifierAmount(i) != 0 ) {
				anyEffects = true;
				switch( cast(int)(i/MODIFIER_SEPERATOR) ) {
				case 0:
					bigFont.draw(modifierNames[i] ~ ": " ~ std.string.toString(PlayerShip.getModifierAmount(i)), 210, y_draw, 255, 20, 20, 255);
					break;
				case 1:
					bigFont.draw(modifierNames[i] ~ ": " ~ std.string.toString(PlayerShip.getModifierAmount(i)), 210, y_draw, 20, 255, 20, 255);
					break;
				}
				y_draw += 20;
			}
		}
		if( anyEffects == false ) bigFont.draw("No current effects.", 210, y_draw, 255, 255, 20, 255);
		if( arc.io.input.keyHit('e') == true ) showingEffects = false;
	} else if( arc.io.input.keyHit('e') == true ) showingEffects = true;
	else showingEffects = false;

	// draw HUD messages
	foreach(int i, char[] HUDM; HUDmessages) {
		if( HUDmessages_a[i] > 0 ) {
			bigFont.draw(HUDM, 200, 515 + (i * 15), HUDmessages_r[i], HUDmessages_g[i], HUDmessages_b[i], HUDmessages_a[i]--);
		}
	}	
}

void drawSensorObject(FU_ITEM playerSensor, FU_OBJECT thing, short r, short g, short b) {
	debug scope(failure) { writefln("drawSensorObject: hud.d"); }
	
	if( playerSensor is null || PlayerShip.getArmor() <= 0 ) return;
	if( thing.getType() == OBJECT_TYPE.SHIP && canSee(PlayerShip, cast(FU_SHIP)thing) == false ) return;
	
	Point pos = Point(thing.getX(), thing.getY());
	Point player_to_thing = pos - Point(PlayerShip.getX(), PlayerShip.getY());
	double objDistance = player_to_thing.length;
	float sensorRange = playerSensor.getVars().maximum * playerSensor.getVars().quality;
	
	if( objDistance < sensorRange ) {
		Point pixel_pos = Point(720, 520);
		if(objDistance != 0)
			pixel_pos += (player_to_thing / objDistance) * (objDistance / sensorRange) * 79;
		
		//FIXME: This is probably extremely inefficient! Instead, sensor blips should be drawn during the hud-phase altogether
		space_view.close();
		interface_view.open();
		// By the way, this doesn't work either
		//pixel_pos = space_view.normalized_to_camera(interface_view.camera_to_normalized(pixel_pos));
		// since the 'pixels' will be smaller if zoomed etc..
		
		drawPixel(cast(int)pixel_pos.getX(), cast(int)pixel_pos.getY(), r, g, b, 255);
		
		interface_view.close();
		space_view.open();
	}
}
