﻿module space.storms;

private import init.init;
private import space.generation;
private import classes.ship;
private import classes.item;

/+
	NULL,	// no storms, yay!
	RED,	// fire, armor
	BLUE,	// ion, shields
	WHITE,	// emp, reduces energy
	GREEN,	// disables sensors, targets
	PURPLE,	// space time, teleports / rotates ships
+/

void drawStorm() {
	switch( MainGenerator.getStormType() ) {
	case STORM_TYPE.NULL:
		return;
	case STORM_TYPE.RED:
		drawRect(0, 0, 800, 600, 255, 0, 0, cast(short)(MainGenerator.getStormAmount()/1.8), true);
		break;
	case STORM_TYPE.BLUE:
		drawRect(0, 0, 800, 600, 0, 0, 255, cast(short)(MainGenerator.getStormAmount()/1.8), true);
		break;
	case STORM_TYPE.WHITE:
		drawRect(0, 0, 800, 600, 255, 255, 255, cast(short)(MainGenerator.getStormAmount()/1.8), true);
		break;
	case STORM_TYPE.GREEN:
		drawRect(0, 0, 800, 600, 0, 255, 0, cast(short)(MainGenerator.getStormAmount()/1.8), true);
		break;
	case STORM_TYPE.PURPLE:
		drawRect(0, 0, 800, 600, 255, 0, 255, cast(short)(MainGenerator.getStormAmount()/1.8), true);
		break;
	}
	MainGenerator.updateStorm();
}

void effectShip(FU_SHIP target) {
	debug scope(failure) { writefln("effectShip: storms.d"); }
	if( objectExists(target) == false ) return;
	if( target.getStormProtection() == MainGenerator.getStormType() ) return;
	if( MainGenerator.getStormAmount() < 75 ) return;
	float magnitude = cast(float)((MainGenerator.getStormAmount() - 74) * MainGenerator.getLevel()) * 0.01;
	switch( MainGenerator.getStormType() ) {
	case STORM_TYPE.NULL:
		return;
	case STORM_TYPE.RED:
		target.damage(magnitude,0.1,0.0,null);
		break;
	case STORM_TYPE.BLUE:
		target.damage(magnitude,0.0,1.0,target);
		break;
	case STORM_TYPE.WHITE:
		{
			float rA, mA;
			target.modifyUtilityCounter(ITEM_CLASS.GENERATOR,-magnitude,&rA,&mA);
		}
		break;
	case STORM_TYPE.GREEN:
		{
			FU_ITEM targetSensor = target.getItem(ITEM_TYPE.UTILITY, ITEM_CLASS.SENSOR,0,true,true);
			if( targetSensor !is null && targetSensor.getLevel() <= MainGenerator.getLevel() ) {
				target.setTarget(null);
				if( target !is PlayerShip ) target.setAIAction(target.defaultAction());
				else targetSensor.setEnable(false);
			}
		}
		break;
	case STORM_TYPE.PURPLE:
		{
			if( MainGenerator.getLevel() >= target.getLevel() && rand()%300==0 ) {
				target.setPosition( MainGenerator.getCellAreaX(), MainGenerator.getCellAreaY() );
				target.setRotation( random_range(0, 360) );
			}
		}
		break;
	}
}
